#include <fstream.h>
#include "dice.h"
#include "dung.h"
#include "ncounter.h"
#include <conio.h>
#include <stdio.h>
#include <ctype.h>

Dungeon::Dungeon(int lev) {
	Level = lev;
	for (int x=0; x<XMAX; x++)
	for (int y=0; y<YMAX; y++) {
		D[x][y] = true;
		Seen[x][y] = false;
		Visited[x][y] = false;
		Mapped[x][y] = false;
		Feat[x][y] = NONE;
	}
    	for (int x = 0; x<XMAX; x+=3)
    	for (int y=0; y<YMAX; y+=3) {
    		if (d10 <= RoomChance) {
    			for (int i=x; i<x+3; i++)
    			for (int j=y; j<y+3; j++)
    				D [i][j] = false;
    		} else {
    			int Flag = 0;
    			if (d10 <= HallChance) { D[x] [y+1] = false; Flag = 1;}
    			if (d10 <= HallChance) { D[x+1] [y] = false; Flag = 1;}
    			if (d10 <= HallChance) { D[x+1] [y+2] = false; Flag = 1;}
    			if (d10 <= HallChance) { D[x+2] [y+1] = false; Flag = 1;}
    			if (Flag) D[x+1] [y+1] = false;
    		}
    	}
	// Scatter some Features
	for (int i=0; i<100; i++) {
		int x,y;
		RandSquare(x,y);
		Feat[x][y] = (Features) d10();
	}
	// Add Encounters
	for (int i=0; i<1000; i++) {
		int x,y;
		RandSquare(x,y);
		Encounter* Enc;
		if (d10 <= 5) Enc = new Treasure (Level);
		else Enc = new Monster (Level);
		Encs[x][y].Push(Enc);
	}
}

void Dungeon::PrintMap(int left, int top, int right, int bottom)
{
//	Dungeon D;

	for (int y=top; y<=bottom; y++) {
		for (int x=left; x<=right; x++) {
//			 cprintf("%c", (IsSolid(x,y) ? 219 : 32));
			cprintf ("%c", PrintChar (x,y));
		}
		gotoxy(1, y-top+1);
	}
}

#define WallLength 7
void Dungeon::HorizWall (int x,int y)
{
	gotoxy(x,y);
	for (int i=0; i<WallLength; i++)
		cprintf ("%c",219);
}

void Dungeon::VertWall(int x, int y)
{
	for (int i=y; i<y+WallLength; i++) {
		gotoxy (x, i);
		cprintf ("%c",219);
	}
}

// Draws a 5x5 box of char 250's
void Dungeon::DrawBlock(int x, int y)
{
	gotoxy (x,y);
	for (int i = 0; i<5; i++)
		cprintf ("%c", 250);

	for (int i=1; i<=3; i++) {
		gotoxy (x, y+i);
		cprintf ("%c   %c",250, 250);
	}
	gotoxy (x, y+4);
	for (int i = 0; i<5; i++)
		cprintf ("%c", 250);

}
// Coordinates for Wall-drawing
#define Wall1 1
#define Wall2 7
#define Wall3 13
#define Wall4 19

// Blocks used in calculating wall visibility
#define BlockA x-1, y-1
#define BlockB x, y-1
#define BlockC x+1, y-1
#define BlockD x-1, y
#define BlockE x,y
#define BlockF x+1, y
#define BlockG x-1, y+1
#define BlockH x, y+1
#define BlockI x+1, y+1
#define BlockJ x-1, y-2
#define BlockK x, y-2
#define BlockL x+1, y-2
#define BlockM x+2, y-1
#define BlockN x+2, y
#define BlockO x+2, y+1
#define BlockP x+1, y+2
#define BlockQ x, y+2
#define BlockR x-1, y+2
#define BlockS x-2, y+1
#define BlockT x-2, y
#define BlockU x-2, y-1

void Dungeon::DrawView (int x, int y, bool Light)
{
	window (61, 1, 80, 21);
	clrscr();
 	if (IsSolid (BlockJ) && IsClear(BlockA) && IsClear(BlockB))
		HorizWall (Wall1,Wall1);
	if (IsSolid (BlockK) && IsClear(BlockB))
		HorizWall (Wall2,Wall1);
	if (IsSolid (BlockL) && IsClear(BlockC) && IsClear(BlockB))
		HorizWall (Wall3,Wall1);
	if (IsSolid (BlockU) && IsClear(BlockA) && IsClear(BlockD))
		VertWall (Wall1,Wall1);
	if (IsSolid (BlockA) && IsClear(BlockB))
		VertWall (Wall2,Wall1);
	if (IsSolid (BlockC) && IsClear(BlockB))
		VertWall (Wall3,Wall1);
	if (IsSolid (BlockM) && IsClear(BlockC) && IsClear(BlockF))
		VertWall (Wall4, Wall1);
	if (IsSolid (BlockA) && IsClear(BlockD))
		HorizWall (Wall1,Wall2);
	if (IsSolid (BlockB))
		HorizWall (Wall2,Wall2);
	if (IsSolid (BlockC) && IsClear (BlockF))
		HorizWall (Wall3,Wall2);
	if (IsSolid (BlockT) && IsClear(BlockD))
		VertWall (Wall1,Wall2);
	if (IsSolid (BlockD))
		VertWall (Wall2,Wall2);
	if (IsSolid (BlockF))
		VertWall (Wall3,Wall2);
	if (IsSolid (BlockN) && IsClear(BlockF))
		VertWall (Wall4,Wall2);
	if (IsSolid (BlockG) && IsClear (BlockD))
		HorizWall (Wall1,Wall3);
	if (IsSolid (BlockH))
		HorizWall (Wall2,Wall3);
	if (IsSolid (BlockI) && IsClear(BlockF))
		HorizWall (Wall3,Wall3);
	if (IsSolid (BlockS) && IsClear(BlockG) && IsClear(BlockD))
		VertWall (Wall1,Wall3);
	if (IsSolid (BlockG) && IsClear(BlockH))
		VertWall (Wall2,Wall3);
	if (IsSolid (BlockI) && IsClear(BlockH))
		VertWall (Wall3,Wall3);
	if (IsSolid (BlockO) && IsClear (BlockI) && IsClear (BlockF))
		VertWall (Wall4,Wall3);
	if (IsSolid (BlockR) && IsClear (BlockG) && IsClear(BlockH))
		HorizWall (Wall1,Wall4);
	if (IsSolid (BlockQ) && IsClear (BlockH))
		HorizWall (Wall2,Wall4);
	if (IsSolid (BlockP) && IsClear (BlockI) && IsClear (BlockH))
		HorizWall (Wall3,Wall4);


	if (IsClear(BlockB) || IsClear(BlockD)) {
		if (IsClear(BlockA)) DrawBlock (Wall1+1, Wall1+1);
		SetSeen(BlockA);
		if (Light) SetMapped(BlockA);
	}
	if (IsClear(BlockD)) DrawBlock (Wall1+1, Wall2+1);
	SetSeen(BlockD);
	if (Light) SetMapped(BlockD);
	if (IsClear(BlockD) || IsClear(BlockH)) {
		if (IsClear(BlockG)) DrawBlock (Wall1+1, Wall3+1);
		SetSeen(BlockG);
		if (Light) SetMapped(BlockG);
	}
	if (IsClear(BlockB)) DrawBlock (Wall2+1, Wall1+1);
	SetSeen(BlockB);
	if (Light) SetMapped(BlockB);
	DrawBlock (Wall2+1, Wall2+1);
	SetSeen (BlockE);
	SetMapped(BlockE);
	SetVisited(BlockE);
	if (IsClear(BlockH)) DrawBlock (Wall2+1, Wall3+1);
	SetSeen(BlockH);
	if (Light) SetMapped(BlockH);
	if (IsClear(BlockB) || IsClear(BlockF)) {
		if (IsClear(BlockC)) DrawBlock (Wall3+1, Wall1+1);
		SetSeen(BlockC);
		if (Light) SetMapped(BlockC);
	}
	if (IsClear(BlockF)) DrawBlock (Wall3+1, Wall2+1);
	SetSeen(BlockF);
	if (Light) SetMapped(BlockF);
	if (IsClear(BlockF) || IsClear(BlockH)) {
		if (IsClear(BlockI)) DrawBlock (Wall3+1, Wall3+1);
		SetSeen(BlockI);
		if (Light) SetMapped(BlockI);
	}
	if (x%3 == 1 || y%3 ==1) {
		SetSeen(BlockA); SetSeen(BlockC);
		SetSeen(BlockG); SetSeen(BlockI);
	}

	// Setseen for blocks 2 squares away (helps mapping)
	if (IsClear(BlockA)) {
		if (IsClear(BlockD)) SetSeen(x-2,y-1);
		if (IsClear(BlockB)) SetSeen(x-1,y-2);
	}
	if (IsClear(BlockB)) {SetSeen(x,y-2);}
	if (IsClear(BlockC)) {
		if (IsClear(BlockF)) SetSeen(x+2,y-1);
		if (IsClear(BlockB)) SetSeen(x+1, y-2);
	}
	if (IsClear(BlockD)) {SetSeen(x-2,y);}
	if (IsClear(BlockF)) {SetSeen(x+2,y);}
	if (IsClear(BlockG)) {
		if (IsClear(BlockD)) SetSeen(x-2,y+1);
		if (IsClear(BlockH)) SetSeen(x-1, y+2);
	}
	if (IsClear(BlockH)) {SetSeen(x,y+2);}
	if (IsClear(BlockI)) {
		if (IsClear(BlockH)) SetSeen (x+1, y+2);
		if (IsClear(BlockF)) SetSeen (x+2, y+1);
	}


	if (IsMapped(BlockA)) PrintFeat(BlockA, Wall1, Wall1);
	if (IsMapped(BlockB)) PrintFeat(BlockB, Wall2, Wall1);
	if (IsMapped(BlockC)) PrintFeat(BlockC, Wall3, Wall1);
	if (IsMapped(BlockD)) PrintFeat(BlockD, Wall1, Wall2);
	if (IsMapped(BlockE)) PrintFeat(BlockE, Wall2, Wall2);
	if (IsMapped(BlockF)) PrintFeat(BlockF, Wall3, Wall2);
	if (IsMapped(BlockG)) PrintFeat(BlockG, Wall1, Wall3);
	if (IsMapped(BlockH)) PrintFeat(BlockH, Wall2, Wall3);
	if (IsMapped(BlockI)) PrintFeat(BlockI, Wall3, Wall3);

	gotoxy ((Wall1+Wall4)/2, (Wall1+Wall4)/2);
	cprintf ("@");
	window (1,1,80,25);
}

unsigned char Dungeon::PrintChar (int x, int y)
{
	if (!IsX(x) || !IsY(y)) {
	 	if ((x>=-1 && x<=XMAX) && (y>= -1 && y<=YMAX))
			return 219;
//		if (y==-1 || y==YMAX) return 219;
		return 32;
	}
	if (!Mapped[x][y] && !Seen[x][y]) return ' ';
//	if (Mapped[x][y] && Encs[x][y].IsMonster()) return 128;
//	if (Mapped[x][y] && Encs[x][y].IsTreasure()) return '$';
	if (IsVisited(x,y) && Encs[x][y].IsMonster()) return '*';
	if (IsMapped(x,y) && Feature(x,y) != NONE) return FeatTypes[Feat[x][y]];
	if (IsVisited(x,y)) return 177; //177
	if (IsSolid(x,y)) return 219;
	if (IsMapped(x,y)) return 249;
	return 250;

}

void Dungeon::RandSquare(int& x, int& y)
{
	static Dice dX(XMAX), dY(YMAX);

	do {
		x = dX-1; y=dY-1;
	} while (IsSolid(x,y));
}

void Dungeon::PrintFeat(int x, int y, int ScreenX, int ScreenY)
{
	gotoxy(ScreenX+2, ScreenY+4);
	switch (Feat[x][y])
	{
		case NONE: cprintf ("   "); break;
		case TPT: cprintf ("TPT"); break;
		case STU: cprintf (" < "); break;
		case STD: cprintf (" > "); break;
		case ALT: cprintf ("ALT"); break;
		case FTN: cprintf ("FTN"); break;
		case THN: cprintf ("THN"); break;
		case STA: cprintf ("STA"); break;
		case ELV: cprintf ("ELV"); break;
		case PIT: cprintf ("PIT"); break;
		case EXC: cprintf ("EXC"); break;
	}
	gotoxy(ScreenX+2, ScreenY+2);
	if (IsVisited(x,y) && Encs[x][y].IsMonster())
		cprintf ("%c%c%c", 128, 128, 128);
//	if (Encs[x][y].IsMonster()) cprintf ("%c%c%c", 128, 128, 128);
//	if (Encs[x][y].IsTreasure()) cprintf ("$$$");
}

void
FountainDrink (Player& P, int Level) {
	int attribute = d4;
	if (d10 < 4) P.LoseAttribute();
	else P.GainAttribute();
}

void
AltarPray (Player& P)
{
	P.Message ("A voice booms out: How would you like to improve yourself?");
	P.Message ("(S)trength, (D)exterity, (C)onstitution, or (L)uck: ");
	char ch;
	do {
		ch = tolower(getch());
	} while (ch != 27 && ch != 's' && ch != 'd' && ch != 'c' && ch != 'l');
	if (ch == 27) return;
	int* attribute;
	switch (ch) {
	case 's':
		attribute = &(P.STR);
		break;
	case 'd':
		attribute = &(P.DEX);
		break;
	case 'c':
		attribute = & (P.CON);
		break;
	case 'l':
		attribute = & (P.LUCK);
		break;
	}
	if (P.PocketGold < *attribute * 500) {
	 	P.Message ("You do not have enough money!");
		P.Pause();
		return;
	}
	char buf[81];
	sprintf (buf, "That will cost %d Gold Pieces", *attribute * 500);
	P.Message (buf);
	P.Message ("Do you wish to pay??");
	do {
		ch = tolower(getch());
	} while (ch != 13 && ch != 'y' && ch != 'n' && ch != '0');
	if (ch == 'n' || ch == '0') return;
	P.PocketGold -= *attribute * 500;
	*attribute += 1;
	P.Status();
	P.Pause();
}

bool ThroneSit (Player& P) {
	P.Message ("You sit on the throne");
	if (P.PocketGold <= 0) {
		P.Message ("Nothing Happens");
		return false;
	}
	P.Message ("Your purse feels lighter all of a sudden");
	P.PocketGold /= 2;
	P.EnchantItem();
	return true;
}

int Dungeon::Play (Player& P, Features& Mech)
{
//	P.D = this;
	RandSquare (P.x, P.y);
	if (Mech == EXC) Feat[P.x][P.y] = EXC;
	if (Mech == STU) Feat[P.x][P.y] = STD;
	if (Mech == STD) Feat[P.x][P.y] = STU;

	char ch = 'q';
	bool draw = true;
	bool evade = false;

	do {
		do {
			if (draw) {
				textcolor(LtGray);
				DrawView (P.x,P.y,(bool) P.MagLight);
				textcolor(LtGray);
				if (P.Map) DrawMap(P);

// Handle encounters;
				evade = false;
				if (!Encs[P.x][P.y]) P.Turn();
				while (!evade && Encs[P.x][P.y]) {
					P.Status();
					P.MsgClear();
					int x =P.x, y = P.y;
					Encounter* Enc  = Encs[x][y].Pop();
					evade = Enc->Resolve(P);
					if (!evade) {
						delete Enc;
					} else {
						Evade(P);
						Encs[x][y].Push (Enc);
						draw = true;
					}
					if (P.CurHP < 0) return 0;
				}

			} else P.Turn();
			// Wandering Monsters
			if (d20 ==1) {
				textcolor (LtGray);
				DrawView(P.x, P.y, (bool) P.MagLight);
				if (P.Map) DrawMap(P);
				int x = P.x, y = P.y;
				Encounter* Enc = new Monster (Level);
				P.Status(); P.MsgClear();
				evade = Enc->Resolve(P);
				P.Turn();
				if (evade) {
					Evade(P);
				 	Encs[x][y].Push(Enc);
					draw = true;
				} else delete Enc;
				if (P.CurHP < 0) return 0;
			}
			if (P.CurHP <0) return 0;
		} while (evade);


		char buf[40];
		P.MsgClear();
//		P.Turn();
		P.Status();

		if (ResolveFeat(P, draw)) {	// ResolveFeat returns true unless changing
								// levels is required.
			draw = false;
			static char Commands[] = {
				'2', '4', '6', '8', '3', '9', '>', '<', '5', '+', '-',
				'q',	's',	'i',	'm',	'u', ' ',	'x', 'c', 0};
			do {
				ch = tolower(getch());
			} while (!strchr (Commands, ch));

     		switch (ch) {
				case 's': {
					ofstream os ("dungeon.map");
					Save(os);
					break;
				}
    				case 'q':
     			case 'Q': {
					ofstream os ("dungeon.map");
					Save(os); // Dungeon is saved so I can eventually restore
							// it, once I get that feature working.
					Level = 0;
					ungetch('q');
					return Level;
				}
     			case '2':
     				if (IsClear(P.x,P.y+1)) {
     					P.y++;
     					draw = true;
     				}
     				break;
     			case '4':
     				if (IsClear(P.x-1,P.y)) {
     					P.x--;
     					draw = true;
     				}
     				break;
     			case '6':
     				if (IsClear (P.x+1, P.y)) {
     					P.x++;
     					draw = true;
     				}
     				break;
     			case '8':
     				if (IsClear (P.x, P.y-1)) {
     					P.y--;
     					draw = true;
     				}
     				break;
				case 'i':
				case 'I':
				case '-':
					if (!P.Potions) {
						P.Message ("You don't have any healing potions");
					} else {
						P.CurHP = P.HitPoints;
						P.Potions--;
						P.Message ("You feel a lot better");
					}
					break;
     			case 'm':
     			case 'M':
					LargeMap(P);
					draw = true;
     				break;
				case '<':
				case '9':
					if (Feature(P.x,P.y) == STU || Feature(P.x,P.y) == ELV) {
//						ch = 'q';
						Level--;
						Mech = STU;
						return Level;
					}
					break;
				case '>':
				case '3':
					if (Feature(P.x, P.y) == STD || Feature (P.x, P.y) == PIT) {
//						ch = 'q';
						Level++;
						Mech = STD;
						return Level;
					}
					break;
     			case 'u':
     			case 'U':
				case ' ':
     				if (!Feature(P.x, P.y)) break;
					switch (Feature (P.x, P.y)) {
    					case STU:
//     					ch = 'q';
     					Level --;
     					Mech = STU;
						return Level;
					case STD:
//     					ch = 'q';
     					Level ++;
     					Mech = STD;
						return Level;
					case FTN:
						FountainDrink (P, Level);
						P.Message ("The fountain dries up");
						Feature (P.x, P.y) = NONE;
						P.Status();
						P.Pause();
						draw = true;
						break;
					case ALT:
						AltarPray (P);
						break;
					case EXC:
     				 	P.Message("Enter number of the level you");
     					P.Message("  would like to enter: ");
     					char buf[30];
     					if (gets(buf)) {
							int L = atoi(buf);
     						if (abs(Level-L) *50 > P.PocketGold) {
							 	P.Message ("You don't have enough money");
							} else {
//								ch = 'q';
	     						Mech = EXC;
								Level = L;
								return Level;
							}
     					}
						break;
					case THN:
						if (ThroneSit(P)) {
							P.Message ("The throne disappears");
							Feat[P.x][P.y] = NONE;
							draw = true;
						}
						P.Pause();
						break;
					case STA:
						P.Message ("The Statue gives you a map of the area");
						DoMapArea(P.x, P.y);
						if (P.Map) DrawMap(P);
						P.Pause();
						break;
					case PIT:
						P.Message ("You climb down the pit");
						P.Pause();
						Mech = PIT;
						return ++Level;
					case ELV:
						P.Message ("You enter the elevator trap");
						P.Pause();
						Mech = ELV;
						return --Level;
					}
     				break;
				case 'x':
				case 'X':
					{ 	char buf [80];
						sprintf (buf, "You need %d Experience Points to advance", P.XPNeeded());
						P.Message(buf);
						P.Pause();
						P.MsgClear();
					}
					break;
				case 'c':
				case 'C':
				case '+':
				{
					SpellType S = P.SpellChoose();
					switch (S) {
					case MTeleport:
						RandSquare(P.x, P.y);
						draw = true;
						break;
					case MAscend:
						Level --;
						Mech = NONE;
						return Level;
					case MDescend:
					 	Level ++;
						Mech = NONE;
						return Level;
					case MChangeLev: {
						P.MsgClear();
     				 	P.Message("Enter number of the level you");
     					P.Message("  would like to enter: ");
     					char buf[30];
     					if (gets(buf)) {
     						Level = atoi(buf);
     						Mech = NONE;
							return Level;
     					}
						break;
					}
					case MapArea:
						DoMapArea(P.x, P.y);
						draw = true;
						break;
					case MapDung:
						DoMapDung();
						draw = true;
						break;
					case MTunnel: {
					 	char ch;
						P.Message ("Which direction?");
						do {
							ch = getch();
						} while (!strchr("2468", ch));
						switch (ch) {
						case '2':
							Map(P.x, P.y+1) = false;
							break;
						case '4':
							Map(P.x-1, P.y) = false;
							break;
						case '6':
							Map(P.x+1, P.y) = false;
							break;
						case '8':
							Map(P.x, P.y-1) = false;
						}
						draw = true;
						break;
					}
					case NoSpell:
//						draw = false;
						break;
					default:
						P.Pause();
//						draw = false;
						break;
					}
				}
					break;
     			default: draw = false;
     		}
		} else {
//			ch = 'q';
			Mech = NONE;
			return Level;
		}
	} while (ch != 'q' && ch != 'Q');

	return Level;
}

bool Dungeon::ResolveFeat(Player& P, bool draw)
{
	char buf[40];

	if (!draw) return true;
 	switch (Feature(P.x, P.y))
	{
	 	case EXC:
			P.Message ("You see the Excelsior Device");
			return true;
		case TPT:
			if (P.SavingThrow(Level)) {
				P.Message ("You avoid the teleport Trap");
				return true;
			}
			P.Message ("You are Teleported!");
			P.Pause();

			RandSquare(P.x, P.y);
			DrawView(P.x, P.y, (bool) P.MagLight);
			if (P.Map) DrawMap(P);
			return true;
		case STU:
			P.Message ("You see stairs up here");
			return true;
		case STD:
			P.Message ("You see stairs down");
			return true;
		case ALT:
			P.Message ("You see an altar here");
			return true;
		case FTN:
			P.Message ("You see a fountain here");
			return true;
		case THN:
			P.Message ("You see a throne here");
			return true;
		case STA:
			P.Message ("You see a Statue here");
			return true;
		case ELV:
			if (P.SavingThrow(Level)) {
				P.Message ("You avoid the elevator trap");
				return true;
			}
			P.Message ("You feel heavier for a moment");
			P.Pause();
			Level--;
			return false;
		case PIT:
			if (P.SavingThrow(Level)) {
			 	P.Message("You avoid the pit");
				return true;
			}
			P.Message ("You fall down a pit");
			P.Pause();
			Level++;
			return false;
	}
	return true;
}

void Dungeon::DrawMap(Player& P) {
	window (1,1,20,20);
	PrintMap (P.x-10, P.y-10, P.x+9, P.y+9);
	gotoxy(11,10); cprintf ("@");
	window (1,1,80,25);
}

struct Direction {
 	int x, y;

};

void Dungeon::Evade(Player& P) {
	static Direction Dir[4] = { {-1, 0}, {1, 0}, {0, -1}, {0, 1}};
	int D = d4-1;
	for (int i=0; i<4; i++) {
		if (IsClear(P.x+Dir[D].x, P.y+Dir[D].y)) {
		 	P.x += Dir[D].x; P.y += Dir[D].y;
			return;
		}
		D = (D+1) %4;
	}
}

void Dungeon::Save (ostream& os) {
	int x,y;
	os << Level << endl;
	for (x = 0; x < XMAX; x++)
	for (y = 0; y < YMAX; y++) {
	 	os << D[x][y] << ' ' << Seen [x][y] << ' ';
		os << Mapped[x][y] << ' ';
		os << Visited[x][y] << ' ' << Feat[x][y] << endl;
	}

	EncounterStack Temp;

	for (x=0; x < XMAX; x++)
	for (y=0; y < YMAX; y++) {
	 	while (Encs[x][y]) {
		 	Temp.Push(Encs[x][y].Pop());
		}
		while (Temp) {
		 	Encounter* E = Temp.Pop();
			os << x << ' ' << y << ' ';
			E->Save(os);
			Encs[x][y].Push (E);
		}
	}
	os << "0 0 3" << endl;
}

void Dungeon::Load (istream& is) {
	int x,y;
	is >> Level;

	cout << "Loading Map Stuff" << endl;
	for (x = 0; x < XMAX; x++) {
		for (y = 0; y < YMAX; y++) {
		 	is >> D[x][y] >> Seen[x][y] >> Mapped[x][y];
			is >> Visited[x][y] >> Feat[x][y];
//cout << D[x][y] << Seen[x][y] << Visited[x][y] << Feat[x][y] << endl;
		}
		cout << x << " finished" << endl;
//		while (getch() != 13);

	}
	cerr << "Clearing old encounters" << endl;
	for (x = 0; x < XMAX; x++)
	for (y = 0; y < YMAX; y++) {
		while (Encs[x][y]) {
			Encounter* E = Encs[x][y].Pop();
			delete E;
		}
	}

	cerr << "Loading new encounters" << endl;
	while (is) {
	 	is >> x >> y;
		int Type;
		is >> Type;
		if (Type == 3) return;
		if (Type == 1) { // Monster
		 	Encounter* E = new Monster(is);
			Encs[x][y].Push(E);
		} else {
			Encounter* E = new Treasure(is);
			Encs[x][y].Push(E);
		}
	}
}

istream& operator>> (istream& is, Features& F) {
 	int I;
	is >> I;
	F = (Features) I;
	return is;
}

void Dungeon::DoMapArea (int x, int y) {
	for (int i=x-10; i< x+10; i++)
	for (int j=y-10; j<y+10; j++)
		SetMapped(i,j);
}

void Dungeon::DoMapDung () {
 	for (int x=0; x<XMAX; x++)
	for (int y=0; y<YMAX; y++)
		SetMapped(x,y);

}

void Dungeon::LargeMap(Player& P) {
 	int j = P.y;
	char ch;
	do {
		window (1,1, 80,25);
		clrscr();
		for (int y = j-10; y < j+10; y++) {
			for (int x = -1; x <= XMAX; x++)
				cout << PrintChar(x,y);
			cout << flush;

		}
		if (P.y >= j-10 && P.y < j+10) {
			gotoxy (P.x+2, P.y-j+11);
			cprintf ("@");
		}
		do {
		 	ch = tolower(getch());
		} while (ch != '2' && ch != '8' && ch != 27);
		if (ch == '2') j++;
		if (ch == '8') j--;
		if (j<0) j=0;
		if (j>=YMAX) j = YMAX-1;
	} while (ch != 27);
	clrscr();
}

