// PLAYER.CC -- Implementation of player class
#include "player.h"
#include "ncounter.h"
#include <iostream.h>
#include <ctype.h>

void Player::Status() {
	char buf [19];
 	textcolor(LtGray);
	StatusPn1.Clear();
	StatusPn2.Clear();
	StatusPn1(Name);
	sprintf(buf, "Level:  %9d", Level);	StatusPn1(buf);
	sprintf(buf, "Exp: %12d", Experience);	StatusPn1(buf);
	sprintf(buf, "STR:    %9d", STR);	StatusPn1(buf);
	sprintf(buf, "DEX:    %9d", DEX);	StatusPn1(buf);
	sprintf(buf, "CON:    %9d", CON);	StatusPn1(buf);
	sprintf(buf, "LUCK:   %9d", LUCK);	StatusPn1(buf);
	sprintf(buf, "HP's:  %10d", CurHP);	StatusPn1(buf);
	sprintf(buf, "$$$: %12d", PocketGold); StatusPn1(buf);
	StatusPn1("Spells:");
	sprintf(buf, "  %3d %3d %3d %3d",
		Spells[0], Spells[1],
		Spells[2], Spells[3]);
	StatusPn1(buf);
	sprintf(buf, "  %3d %3d %3d %3d",
		Wands[0], Wands[1],
		Wands[2], Wands[3]);
	StatusPn1(buf);
	sprintf (buf, "Turn: %11d", TurnNo);
	StatusPn1(buf);
	if (Sword) sprintf(buf, "Sword   %+10d", Sword); else strcpy(buf," ");
	StatusPn2(buf);
	if (Shield) sprintf(buf, "Shield  %+10d", Shield); else strcpy(buf, " ");
	StatusPn2(buf);
	if (Armor) sprintf(buf, "Armor   %+10d", Armor); else strcpy(buf, " ");
	StatusPn2(buf);
	if (Ring) sprintf(buf, "Ring    %+10d", Ring); else strcpy(buf, " ");
	StatusPn2(buf);
	if (Boots) sprintf(buf, "Boots   %+10d", Boots); else strcpy(buf, " ");
	StatusPn2(buf);
	if (Amulet) sprintf(buf, "Amulet  %+10d", Amulet);  else strcpy(buf, " ");
	StatusPn2(buf);
	sprintf(buf, "Grenades: %8d", Grenades); StatusPn2(buf);
	sprintf(buf, "Potions:  %8d", Potions); StatusPn2(buf);
	sprintf (buf, "Bank: %12d", BankGold); StatusPn2(buf);
	if (MagLight) StatusPn2 ("Light");
	if (Strength) StatusPn2 ("Strong");
	if (Agility) StatusPn2 ("Agile");
	if (StoneSkin) StatusPn2 ("StoneSkin");
	if (Fortune) StatusPn2 ("Fortune");
	if (SpeedHeal) StatusPn2 ("SpeedHeal");
}

Player::Player(char N[] = "?????") : MessageWnd(1,21,80,25),
	x(0), y(0), Map(true),
	StatusPn1(22,1,40,20), StatusPn2(42, 1, 59, 20)
{
	STR = max(d6(3),d6(3));
	DEX = max(d6(3),d6(3));
	CON = max(d6(3),d6(3));
	LUCK = max(d6(3),d6(3));
	Agility = Strength = Fortune = StoneSkin = MagLight = SpeedHeal = 0;
	Potions = 0;
	Level = 1;
	Spells[0] = Level;
	Spells[1] = Level/2;
	Spells[2] = Level/4;
	Spells[4] = Level/8;
	for (int i=0; i<4; i++) Wands[i] = 0;
	CurHP = HitPoints = CON + od8(3);
	Sword = Shield = Armor = Ring = Boots = Grenades = Amulet = 0;
	PocketGold = BankGold = 0;
	Experience = 0;
	TurnNo = 0;
	strcpy(Name, N);
}

void Player::Turn()
{
	TurnNo++;
	if (Ring) Heal (Ring);
	if (SpeedHeal && (CurHP < HitPoints)) {Heal (Ring); SpeedHeal--;}
	if (MagLight) MagLight --;
	// Restore Spells at rare intervals
	if (TurnNo % 125 == 0 && Spells[0] < Level) Spells[0]++;
	if (TurnNo % 250 == 0 && Spells[1] < Level/2) Spells[1]++;
	if (TurnNo % 500 == 0 && Spells[2] < Level/4) Spells[2]++;
	if (TurnNo % 1000 == 0 && Spells[3] < Level/8) Spells[3]++;

	while (Experience > XPNeeded()) UpLevel();

}

void Player::UpLevel()
{
	Level++;
	char buf[100];
	sprintf (buf, "You have reached level %d!", Level);
	Message(buf);
	int roll = od8 + max (CON-12, 0);
	sprintf (buf, "You get %d additional Hit Points", roll);
	HitPoints += roll; CurHP += roll;
	Message (buf);

	Spells[0] ++;
	if (!(Level % 2)) Spells[1]++;
	if (!(Level % 4)) Spells[2]++;
	if (!(Level % 8)) Spells[3]++;

	Status();
	Pause();
	MsgClear();
}

void Player::Save (ostream& os)
{
 	os << Name << endl;
	os << Level << endl;
	os << HitPoints << endl;
	os << STR << endl;
	os << DEX << endl;
	os << CON << endl;
	os << LUCK << endl;
	os << Experience << endl;
	os << CurHP << endl;
	os << Sword << endl;
	os << Shield << endl;
	os << Armor << endl;
	os << Ring << endl;
	os << Boots << endl;
	os << Amulet << endl;
	os << Grenades << endl;
	os << PocketGold << endl;
	os << BankGold << endl;
	os << Map << endl;
	os << TurnNo << endl;
	os << Agility << endl;
	os << Strength << endl;
	os << Fortune << endl;
	os << SpeedHeal << endl;
	os << StoneSkin << endl;
	os << MagLight << endl;
	os << Potions << endl;
	for (int i=0; i<4; i++) {
		os << Spells[i] << endl;
		os << Wands[i] << endl;
	}
}

void Player::Load (istream& is)
{
	is.getline (Name, 20);
	is >> Level >> HitPoints >> STR >> DEX >> CON >> LUCK;
	is >> Experience >> CurHP >> Sword >> Shield >> Armor;
	is >> Ring >> Boots >> Amulet >> Grenades >> PocketGold >> BankGold;
	is >> Map >> TurnNo >> Agility >> Strength >> Fortune >> SpeedHeal;
	is >> StoneSkin >> MagLight >> Potions;

	for (int i=0; i<4; i++) {
		is >> Spells[i] >> Wands[i];
	}
}

bool Player::LoseSpell (int L)
{
	if (Spells[L-1]) Spells[L-1]--;
	else if (Wands[L-1]) Wands[L-1]--;
	else {
		Message ("You can't cast that spell!");
		return false;
	}
	return true;
}

void Player::SpellPrint()
{
	Message ("A. Fortune            B. Minor Cure      C. Light         M. Tunnel");
	Message ("D. Map Area           E. Continual Light F. Descend Level N. SpeedHeal");
	Message ("G. Teleport           H. Major Cure      I. Ascend Level");
	Message ("J. Map Dungeon        K. Heal All Wounds L. Change Level");
	Message ("Choose a Spell (ESC Cancels)");
}

SpellType Player::SpellChoose()
{
	SpellPrint();
	char ch;
	do {
		ch = tolower (getch());
	} while (ch != 27 && (ch < 'a' || ch > 'n'));
	if (ch == 27) return NoSpell;
	switch (ch) {
	  	case 'a':
			if (!LoseSpell(1)) return NoSpell;
			Message ("You feel lucky today!!");
			Fortune = LUCK;
			return MFortune;
		case 'b':
			if (!LoseSpell(1)) return NoSpell;
			Message ("You feel better");
			Heal (od4(Level/2+1));
			return MinCure;
		case 'c':
			if (!LoseSpell(1)) return NoSpell;
			Message ("A glowing ball of light appears above your palm");
			MagLight = max (MagLight, LUCK);
			return MLight;
		case 'd':
			if (!LoseSpell(2)) return NoSpell;
			Message ("You feel enlightened");
			return MapArea;
		case 'e':
			if (!LoseSpell(2)) return NoSpell;
			Message ("A bright ball of light appears");
			MagLight = (int) pow2(30);
			return MContLight;
		case	'f':
			if (!LoseSpell(2)) return NoSpell;
			Message ("You sink through the floor");
			return MDescend;
		case	'g':
			if (!LoseSpell(3)) return NoSpell;
			Message ("You are teleported!!");
			return MTeleport;
		case 'h':
			if (!LoseSpell(3)) return NoSpell;
			Message ("You feel much better");
			Heal (od6(Level));
			return MajCure;
		case 'i':
			if (!LoseSpell(3)) return NoSpell;
			Message ("You ascend through the ceiling");
			return MAscend;
		case 'j':
			if (!LoseSpell(4)) return NoSpell;
			Message ("You feel knowledge enter your mind");
			return MapDung;
		case 'k':
			if (!LoseSpell(4)) return NoSpell;
			Message ("You are completely healed");
			CurHP = HitPoints;
			return HealAll;
		case 'l':
			if (!LoseSpell(4)) return NoSpell;
			return MChangeLev;
		case 'm':
			if (!LoseSpell(1)) return NoSpell;
			return MTunnel;
		case 'n':
			if (!LoseSpell(2)) return NoSpell;
			Message ("You start healing faster!!");
			SpeedHeal = max (SpeedHeal, LUCK);
			return MSpeedHeal;
	}
}

void Player::SpellPrintCombat()
{
	Message ("A. Magic Missile      B. Minor Cure      C. Evade");
	Message ("D. Fireball           E. Agility         F. Strength");
	Message ("G. Super Agility      H. Major Cure      I. Stone Skin");
	Message ("J. Lightning Bolt     K. Heal All Wounds L. Vampiric Drain");
	Message ("Choose a Spell (ESC Cancels)");
}


SpellType Player::SpellChoose(Monster& M)
{
	SpellPrintCombat();
	char ch;
	do {
		ch = tolower (getch());
	} while (ch != 27 && (ch < 'a' || ch > 'l'));
	if (ch == 27) return NoSpell;
	char buf[80];
	switch (ch) {
	  	case 'a':
			if (!LoseSpell(1)) return NoSpell;
			sprintf (buf, "Your missile does %d points of damage to the %s", M.TakeHit(od8(Level/3+1)+2*Level), M.Name);
			Message(buf);
			return MMissile;
		case 'b':
			if (!LoseSpell(1)) return NoSpell;
			Message ("You feel better");
			Heal (od4(Level/2+1));
			return MinCure;
		case 'c':
			if (!LoseSpell(1)) return NoSpell;
			Message ("You escape the monster");
			return MEvade;
		case 'd':
			if (!LoseSpell(2)) return NoSpell;
			sprintf (buf, "The exploding fireball does %d points of damage to the %s", M.TakeHit(od6(Level) + 4*Level), M.Name);
			Message (buf);
			return FireBall;
		case 'e':
			if (!LoseSpell(2)) return NoSpell;
			Message ("You feel extremely agile!!");
			Agility = max(Agility, DEX);
			return MAgility;
		case 'f':
			if (!LoseSpell(2)) return NoSpell;
			Message ("You feel extremely strong!!");
			Strength = max (Strength, STR);
			return MStrength;
		case 'g':
			if (!LoseSpell(3)) return NoSpell;
			Message ("You feel Supremely agile!!");
			Agility = max (Agility, 2* DEX);
			return SupAgility;
		case 'h':
			if (!LoseSpell(3)) return NoSpell;
			Message ("You feel much better");
			Heal (od6(Level));
			return MajCure;
		case 'i':
			if (!LoseSpell(3)) return NoSpell;
 			Message ("Your skin feels extremely tough!!");
			StoneSkin = max (StoneSkin, CON);
			return MStoneSkin;
		case 'j':
			if (!LoseSpell(4)) return NoSpell;
			sprintf (buf, "The lightning bolt hits the %s for %d points of damage", M.Name, M.TakeHit(od4(Level) + 6*Level));
			Message(buf);
			return LBolt;
		case 'k':
			if (!LoseSpell(4)) return NoSpell;
			Message ("You are completely healed");
			CurHP = HitPoints;
			return HealAll;
		case 'l':
			if (!LoseSpell(4)) return NoSpell;
			Message ("You feel like a vampire!!");
			return VampDrain;

	}
}

int Player::Roll(int Num, int Sides) {
 	Dice D(Sides);
	return D(Num);
}

void Player::Create()
{
	STR = max(d6(3),d6(3));
	DEX = max(d6(3),d6(3));
	CON = max(d6(3),d6(3));
	LUCK = max(d6(3),d6(3));
	Agility = Strength = StoneSkin = Fortune = MagLight = SpeedHeal = 0;
	Level = 1;
	Spells[0] = Level;
	Spells[1] = Level/2;
	Spells[2] = Level/4;
	Spells[3] = Level/8;
	for (int i=0; i<4; i++) Wands[i] = 0;
	CurHP = HitPoints = CON + d8(3);
	Sword = Shield = Armor = Ring = Boots = Grenades = Amulet = 0;
	Potions = 0;
	PocketGold = BankGold = 0;
	Experience = 0;
	TurnNo = 0;
//	strcpy(Name, N);
}

void Player::Disenchant()
{
	switch (Roll(1,6)) {
	case 1: Message ("Your sword glows black");
		Sword --;
		break;
	case 2: Message ("Your armor glows black");
		Armor --;
		break;
	case 3: Message ("Your shield glows black");
		Shield --;
		break;
	case 4: if (Ring) Message ("Your magic ring glows black");
		if (Ring) Ring --;
		break;
	case 5: Message ("Your magic amulet glows black");
		Amulet --;
		break;
	case 6: Message ("Your elven boots glow black");
		Boots --;
		break;
	}
}

void Player::GainAttribute() {
	int attribute = d4;
	switch (attribute) {
	case 1:
		Message ("You feel stronger");
		STR++;
		break;
	case 2:
		Message ("You feel agile");
		DEX++;
		break;
	case 3:
		Message ("You feel healthy");
		CON++;
		break;
	case 4:
		Message ("You feel lucky today");
		LUCK++;
		break;
	}
	Status();
}

void Player::LoseAttribute () {
	int attribute = d4;
	switch (attribute) {
	case 1:
		Message ("You feel weaker");
		STR--;
		break;
	case 2:
		Message ("You feel clumsier");
		DEX--;
		break;
	case 3:
		Message ("You feel sickly");
		CON--;
		break;
	case 4:
		Message ("You feel unlucky");
		LUCK--;
		break;
	}
	Status();
//	Pause();
}


void Player::EnchantItem()
{
	switch (Roll(1,6)) {
	case 1: Message ("Your sword glows blue");
		Sword ++;
		break;
	case 2: Message ("Your armor glows brightly");
		Armor ++;
		break;
	case 3: Message ("Your shield glows blue");
		Shield ++;
		break;
	case 4: Message ("Your magic ring glows amber");
		Ring ++;
		break;
	case 5: Message ("Your magic amulet glows red");
		Amulet ++;
		break;
	case 6: Message ("Your elven boots glow green");
		Boots++;
		break;
	}
}

