#include "dung.h"
#include "dice.h"
#include <conio.h>
#include <stdio.h>
#include "player.h"
#include <fstream.h>
#include <ctype.h>

void ImproveItem (int& Item, char* Name, Player& P) {
 	cout << "You have a +" << Item << " bonus from your " << Name << "." << endl;
	cout << "Magic items cost 1000 times the square of the bonus gold pieces." << endl;
	if (Item > 0) {
		cout << "Your old " << Name << " can be traded in for ";
		cout << Item * Item * 500 << " gold pieces." << endl;
	}
	cout << "What bonus would you like to have? ";
	int newItem;
	cin >> newItem;
	if (newItem == 0) return;
	if (newItem <= Item) {
		cout << "You already have a +" << Item << " bonus." << endl;
		cout << "Press <Enter> to continue" << endl;
		while (getch() != 13);
		return;
	}
	int Price = newItem * newItem * 1000;
 	if (Item > 0) Price -= Item * Item * 500;
	if (Price > P.BankGold) {
		cout << "You don't have " << Price << " gold pieces to spend!!" << endl;
		cout << "Press <Enter> to contine" << endl;
		while (getch() != 13);
		return;
	}
	cout << "That will cost " << Price << " gold pieces." << endl;
	cout << "Do you want to buy it?" << endl;
	char ch;
	do
		ch = tolower (getch());
	while (ch != 'y' && ch != 'n');
	if (ch == 'n') return;
	Item = newItem;
	P.BankGold -= Price;
}

void BuyWands(Player& P)
{
	cout << "What spell level would you like to buy? (1-4)" << endl;
	char ch;
	do {
		ch = getch();
	} while (ch != 27 && (ch < '0' || ch > '4'));
	if (ch ==27 || ch == '0') return;
	int Level = ch - '0';
	cout << "Level " << Level << " scrolls cost " << Level * Level * 500;
	cout << " gold pieces per charge" << endl;
	cout << "How many charges do you wish to purchase? " << endl;
	char buf[30];
	cin.getline (buf, 30);
	int Charges = atoi (buf);
	if (Charges == 0) return;
	int Price = Charges * Level * Level * 500;
	cout << "That will cost " << Price << " gold pieces." << endl;
	if (Price > P.BankGold) {
		cout << "You do not have enough money" << endl;
		cout << "Press <Enter> to continue" << endl;
		while (getch() != 13);
		return;
	}
	cout << "Do you wish to purchase the scroll? " << endl;
	do
		ch = tolower (getch());
	while (ch != 'y' && ch != 'n');
	if (ch == 'n') return;
	P.Wands[Level-1] += Charges;
	P.BankGold -= Price;
}

void BuyItems (int& Item, char* Name, int PricePer, Player& P)
{
	cout << Name << " cost " << PricePer << " gold pieces each." << endl;
	cout << "How many do you want to buy?" << endl;
	fflush(stdin);
	char buf[30];
//	cin.getline (buf, 30);
	gets(buf);
	int Number = atoi (buf);
	if (Number == 0) return;
	int Price = Number * PricePer;
	cout << Number << " " << Name << " will cost " << Price << " gold pieces" << endl;
	if (Price > P.BankGold) {
		cout << "You do not have enough money" << endl;
		cout << "Press <Enter> to continue" << endl;
		while (getch() != 13);
		return;
	}
	cout << "Do you wish to buy them?" << endl;
	char ch;
	do
		ch = tolower (getch());
	while (ch != 'y' && ch != 'n');
	if (ch == 'n') return;
	Item += Number;
	P.BankGold -= Price;
}

void ImproveAttributes (Player& P)
{
	cout << "Which attribute would you like to improve?" << endl;
	cout << "(S)trength:     " << P.STR << endl;
	cout << "(D)exterity:    " << P.DEX << endl;
	cout << "(C)onstitution: " << P.CON << endl;
	cout << "(L)uck:         " << P.LUCK << endl;
	char ch;
	do {
		ch = tolower(getch());
	} while (ch != 27 && ch != 's' && ch != 'd' && ch != 'c' && ch != 'l');
	if (ch == 27) return;
	int* attribute;
	switch (ch) {
	case 's':
		attribute = &(P.STR);
		break;
	case 'd':
		attribute = &(P.DEX);
		break;
	case 'c':
		attribute = & (P.CON);
		break;
	case 'l':
		attribute = & (P.LUCK);
		break;
	}
	if (P.BankGold < *attribute * 1000) {
		cout << "You do not have enough money" << endl;
		cout << "Press <Enter> to continue" << endl;
		while (getch() != 13);
		return;
	}
	cout << "That will cost " << *attribute * 1000 << " Gold Pieces" << endl;
	cout << "Do you wish to pay??" << endl;
	do {
		ch = tolower(getch());
	} while (ch != 13 && ch != 'y' && ch != 'n' && ch != '0');
	if (ch == 'n' || ch == '0') return;
	P.BankGold -= *attribute * 1000;
	*attribute += 1;
	cout << "Press <Enter> to continue" << endl;
	while (getch() != 13);
}

void EnterStore(Player& P) {
	char ch;
	do {
      	window (1,1,80,25);
     	clrscr();
     	cout << "Money to spend: $" << P.BankGold << endl;
     	cout << "A. Swords" << endl;
     	cout << "B. Shields" << endl;
     	cout << "C. Armor" << endl;
     	cout << "D. Magic Rings" << endl;
     	cout << "E. Magic Amulets" << endl;
     	cout << "F. Elven Boots" << endl;
     	cout << "G. Magic Scrolls" << endl;
     	cout << "H. Hand Grenades" << endl;
     	cout << "I. Healing Potions" << endl;
     	cout << "J. Improve Attributes" << endl;
     	cout << "Q. Quit Store (also ESC)" << endl;
     	cout << "Enter your choice" << endl;
     	do
     		ch = tolower (getch());
     	while ((ch < 'a' || ch > 'j') && ch != 'q' && ch != 27);
     	if (ch == 27 || ch == 'q') return;
		cout << endl;
		fflush(stdin);
     	switch (ch) {
     	case 'a':
     		ImproveItem(P.Sword, "sword", P);
     		break;
		case 'b':
			ImproveItem (P.Shield, "shield", P);
			break;
		case 'c':
			ImproveItem (P.Armor, "armor", P);
			break;
		case 'd':
			ImproveItem (P.Ring, "magic ring", P);
			break;
		case 'e':
			ImproveItem (P.Amulet, "magical amulet", P);
			break;
		case 'f':
			ImproveItem (P.Boots, "elven boots", P);
			break;
		case 'g':
			BuyWands (P);
			break;
		case 'h':
			BuyItems (P.Grenades, "Grenades", P.Level * 1000, P);
			break;
		case 'i':
			BuyItems (P.Potions, "Potions", P.Level * 500, P);
			break;
		case 'j':
			ImproveAttributes(P);
			break;
     	}
	} while (ch != 'q');
	clrscr();
}

void Run (Player& P) {
	Dungeon* D = NULL;
	window (1,1,80,25);
	clrscr();
/*	{
		ifstream is ("dungeon.map");
		if (is) {
			D->Load(is);
		}
		system ("delete dungeon.map");
	}  */
	do {
     	Features Mech (STD);
		P.Status();
		if (!D) P.Message ("What Dungeon level would you like to enter? ");
     	int level = 1;
		if (!D) cin >> level;
		if (level < 1) level = 1;
     	if (!D) D = new Dungeon(level);

     	while (level = D->Play(P, Mech)) D = new Dungeon(level);

		delete D;
		D = NULL;

		if (P.CurHP >= 0) {
			P.CurHP = P.HitPoints;
			// Spells are restored
			P.Spells[0] = P.Level;
			P.Spells[1] = P.Level/2;
			P.Spells[2] = P.Level/4;
			P.Spells[3] = P.Level/8;
			// Money is transferred to bank
			P.BankGold += P.PocketGold;
			P.Experience += P.PocketGold/P.Level;
			P.PocketGold = 0;
			// Magical bonuses expire
			P.Agility = P.Strength = P.Fortune = P.SpeedHeal = P.StoneSkin
				= P.MagLight = 0;
			P.Turn();	// In case of a level increase;
			// Show updated character
			P.Status();
			window (61, 1, 80, 21); clrscr(); // Clear view window
			window (1,1,20,20); clrscr(); // Clear map window
			P.MsgClear();
			P.Message ("You have left the dungeon!!");
			P.Message ("Press <Enter> to re-enter dungeon, or 'q' to quit");
			char ch;
			do ch = getch(); while (ch != 13 && ch != 'q' && ch != 'Q');
			if (ch != 13) break; // Leaves do loop
		}
	} while (P.CurHP >= 0);

}

void CreatePlayer(Player& P) {
	window (1,1,80,25);
	clrscr();
	char ch;
	do {
		P.Create();
		P.Status();
		P.MsgClear();
		P.Message ("Play this Character?");
		ch = tolower (getch());
	} while (ch != 'y' && ch != 13);
	P.Message ("Enter the character's name: ");
	fflush(stdin);
	do {
		cin.getline (P.Name, 20);
	} while (strcmp (P.Name, "") == 0);
}

main()
{
	clrscr();
	_setcursortype (_NOCURSOR);
	textcolor(LtGray);

	Player P;
	{
		ifstream is ("dung001.sav");
		if (is) P.Load(is);
		else CreatePlayer (P);
	}

	char ch;
	do {
	    	window (1,1,80,25);
    		clrscr();
		cout << P.Name << ", Level: " << P.Level << " Gold: " << P.BankGold << endl;
		cout << "B. Backup Character" << endl;
		cout << "L. Load Character" << endl;
		cout << "Q. Quit Game" << endl;
    		cout << "R. Run Character" << endl;
		cout	<< "S. Enter Store" << endl;

		do
			ch = tolower(getch());
		while (!strchr ("blqrs", ch));
		switch (ch) {
		case 'r':
			Run (P);
			break;
		case 's':
			EnterStore(P);
			break;
		case 'b': {
		 	ofstream os ("dung004.sav");
			P.Save(os);
		}
			break;
		case 'l': {
			ifstream is ("dung004.sav");
			if (is) P.Load(is);
		}
			break;
		}
		if (ch == 'q') break;
	    	window (1,1,80,25);
    		clrscr();
		if (P.CurHP < 0) CreatePlayer(P);
	} while (ch != 'q');


	_setcursortype (_NORMALCURSOR);
    	window (1,1,80,25);
	clrscr();

	if (P.CurHP <0) system ("delete dung001.sav >NULL");
	else {
		ofstream os ("dung001.sav");
		P.Save(os);
	}
}

