// SSTRING.H -- Stack based string

#ifndef SSTRING_H_
#define SSTRING_H_

#include <string.h>
#include <iostream.h>
#include <stdlib.h>

class SString {
	char* s;
public:
	SString(const char* S = "") : s(NULL) {
		s = new char[strlen(S) + 1];
		strcpy (s, S);
	}
	SString (const SString& rv) :s(NULL) {
		s = new char[strlen(rv.s) + 1];
		strcpy (s, rv.s);
	}
	SString (int num) :s(NULL) {
		char buf[33];
		itoa (num, buf, 10);
		s = new char[strlen(buf) + 1];
		strcpy(s, buf);
	}
	SString (unsigned char ch) : s(NULL) {
		s = new char[2];
		s[0] = ch; s[1] = 0;
	}

	SString& operator=(const SString& rv) {
		// Check for self-assignment
		if (&rv == this) return *this;
		delete s;
		s = new char[strlen(rv.s) +1];
		// Constructor guarantees length < bsz
		strcpy (s, rv.s);
		return *this;
	}
	~SString () {
		delete []s; 
	}
	int operator== (const SString& rv) const {
		return !strcmp(s, rv.s);
	}
	int operator!= (const SString& rv) const {
		return strcmp(s, rv.s);
	}
	int operator> (const SString& rv) const {
		return strcmp(s, rv.s) > 0;
	}
	int operator< (const SString& rv) const {
		return strcmp(s, rv.s) < 0;
	}
	char* str() const {return s;}
	operator const char*() const {return s;}
	friend const SString operator+ (const SString& left,
					const SString& right) {
		int ln = strlen (left.s) + strlen (right.s)+1;
		char* str = new char[ln];
		strcpy (str, left.s);
		strcat (str, right.s);
		SString result (str);
		return result;
	}
	friend SString& operator+= (SString& left, 
				const SString& right) {
		if (&left != &right) {
			left = left + right;
			return left;
		}
	}		
	friend ostream& operator<< (ostream& os, const SString& S) {
		return os << S.s;
	}
	friend istream& operator>> (istream& is, SString& S) {
		char buf[1024];
		is.getline(buf, 1024);
		SString result(buf);
		S = result;
		return is;
	}
};

typedef SString HString; // Heap String
#endif // SSTRING_H_

